/*
 * The Clear BSD License
 * Copyright 2017-2018 NXP
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted (subject to the limitations in the disclaimer below) provided
 *  that the following conditions are met:
 *
 * o Redistributions of source code must retain the above copyright notice, this list
 *   of conditions and the following disclaimer.
 *
 * o Redistributions in binary form must reproduce the above copyright notice, this
 *   list of conditions and the following disclaimer in the documentation and/or
 *   other materials provided with the distribution.
 *
 * o Neither the name of the copyright holder nor the names of its
 *   contributors may be used to endorse or promote products derived from this
 *   software without specific prior written permission.
 *
 * NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE.
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/***********************************************************************************************************************
 * This file was generated by the MCUXpresso Config Tools. Any manual edits made to this file
 * will be overwritten if the respective MCUXpresso Config Tools is used to update this file.
 **********************************************************************************************************************/

#ifndef _PIN_MUX_H_
#define _PIN_MUX_H_

/*!
 * @addtogroup pin_mux
 * @{
 */

/***********************************************************************************************************************
 * API
 **********************************************************************************************************************/

#if defined(__cplusplus)
extern "C" {
#endif

/*!
 * @brief Calls initialization functions.
 *
 */
void BOARD_InitBootPins(void);

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitPins(void);

#define SOPT5_UART0TXSRC_UART_TX 0x00u /*!<@brief UART 0 transmit data source select: UART0_TX pin */

/*! @name PORTB17 (coord E9), ExtConn[7]/UART0_TX
  @{ */
#define BOARD_UART0_TX_PORT PORTB /*!<@brief PORT device name: PORTB */
#define BOARD_UART0_TX_PIN 17U    /*!<@brief PORTB pin index: 17 */
                                  /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitDEBUG_UART(void);

/*! @name PORTE24 (coord H5), U4[42]/UART4_TX
  @{ */
#define BOARD_UART4_TX_PORT PORTE /*!<@brief PORT device name: PORTE */
#define BOARD_UART4_TX_PIN 24U    /*!<@brief PORTE pin index: 24 */
                                  /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitKW40_UART(void);

#define PORT_DFER_DFE_15_MASK 0x8000u /*!<@brief Digital Filter Enable Mask for item 15. */

/*! @name PORTB20 (coord F10), OLED1[9]/OLED_CS
  @{ */
#define BOARD_OLED_CS_GPIO GPIOB /*!<@brief GPIO device name: GPIOB */
#define BOARD_OLED_CS_PORT PORTB /*!<@brief PORT device name: PORTB */
#define BOARD_OLED_CS_PIN 20U    /*!<@brief PORTB pin index: 20 */
                                 /* @} */

/*! @name PORTC13 (coord A6), U11[3]/OLED_PWR
  @{ */
#define BOARD_OLED_PWR_GPIO GPIOC /*!<@brief GPIO device name: GPIOC */
#define BOARD_OLED_PWR_PORT PORTC /*!<@brief PORT device name: PORTC */
#define BOARD_OLED_PWR_PIN 13U    /*!<@brief PORTC pin index: 13 */
                                  /* @} */

/*! @name PORTD15 (coord E1), OLED1[8]/OLED_DC
  @{ */
#define BOARD_OLED_DC_GPIO GPIOD /*!<@brief GPIO device name: GPIOD */
#define BOARD_OLED_DC_PORT PORTD /*!<@brief PORT device name: PORTD */
#define BOARD_OLED_DC_PIN 15U    /*!<@brief PORTD pin index: 15 */
                                 /* @} */

/*! @name PORTE6 (coord F3), OLED1[7]/OLED_RST
  @{ */
#define BOARD_OLED_RST_GPIO GPIOE /*!<@brief GPIO device name: GPIOE */
#define BOARD_OLED_RST_PORT PORTE /*!<@brief PORT device name: PORTE */
#define BOARD_OLED_RST_PIN 6U     /*!<@brief PORTE pin index: 6 */
                                  /* @} */

/*! @name PORTB22 (coord F8), OLED1[15]/OLED_SDI
  @{ */
#define BOARD_OLED_SPI_SDI_PORT PORTB /*!<@brief PORT device name: PORTB */
#define BOARD_OLED_SPI_SDI_PIN 22U    /*!<@brief PORTB pin index: 22 */
                                      /* @} */

/*! @name PORTB21 (coord F9), OLED[14]/OLED_SCK
  @{ */
#define BOARD_OLED_SPI_SCLK_PORT PORTB /*!<@brief PORT device name: PORTB */
#define BOARD_OLED_SPI_SCLK_PIN 21U    /*!<@brief PORTB pin index: 21 */
                                       /* @} */

/*! @name PORTB23 (coord E8), MISO_NOT_USED
  @{ */
#define BOARD_MISO_NOT_USED_PORT PORTB /*!<@brief PORT device name: PORTB */
#define BOARD_MISO_NOT_USED_PIN 23U    /*!<@brief PORTB pin index: 23 */
                                       /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitOLED_DSPI(void);

/*! @name XTAL32 (coord L4), X1[1]/XL1
  @{ */
/* @} */

/*! @name EXTAL32 (coord L5), X1[2]/XL2
  @{ */
/* @} */

/*! @name PORTA19 (coord K11), Y1[3]/XTAL0
  @{ */
#define BOARD_XTAL0_PORT PORTA /*!<@brief PORT device name: PORTA */
#define BOARD_XTAL0_PIN 19U    /*!<@brief PORTA pin index: 19 */
                               /* @} */

/*! @name PORTA18 (coord L11), Y1[1]/EXTAL0
  @{ */
#define BOARD_EXTAL0_PORT PORTA /*!<@brief PORT device name: PORTA */
#define BOARD_EXTAL0_PIN 18U    /*!<@brief PORTA pin index: 18 */
                                /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitOSC(void);

#if defined(__cplusplus)
}
#endif

/*!
 * @}
 */
#endif /* _PIN_MUX_H_ */

/***********************************************************************************************************************
 * EOF
 **********************************************************************************************************************/
